GLOBAL EXPORTS
section '.exprt' align 16
;**********************************************************************************
EXPORTS: ;/////////////////////////////////////////////////////////////////////////
;**********************************************************************************
dd sz__getch,     _getch
dd sz__kbhit,     _kbhit
dd sz_printf,     printf
dd 0
sz__getch         db "_getch",0
sz__kbhit         db "_kbhit",0
sz_printf         db "printf",0

section '.code' align 16
align 16
;**********************************************************************************
_getch: ;//////////////////////////////////////////////////////////////////////////
;**********************************************************************************
        push   ebx
        push   esi
        push   edi

        call   load_console_lib
        call   [con_getch]

        pop    edi
        pop    esi
        pop    ebx
        ret
align 16				
;**********************************************************************************
_kbhit: ;//////////////////////////////////////////////////////////////////////////
;**********************************************************************************
        push   ebx
        push   esi
        push   edi

        call   load_console_lib
        call   [con_kbhit]

        pop    edi
        pop    esi
        pop    ebx
        ret
align 16
;**********************************************************************************
printf: ;//////////////////////////////////////////////////////////////////////////
;**********************************************************************************
        ; pushad
        ; push   ebx
        ; push   esi
        ; push   edi
        call   load_console_lib
				; popad
        call   [con_printf]

        ; pop    edi
        ; pop    esi
        ; pop    ebx
				
        ret

				
load_console_lib:
; if already loaded then do nothing
        cmp    [console], dword 0
        jne    .do_nothing
        push   sz_console
        call   load.library
        mov    [console], eax
        mov    ecx, eax
        mov    ebx, getprocaddress
        push   ecx
        push   sz_con_getch
        call   ebx
        mov    [con_getch], eax
        push   ecx
        push   sz_con_kbhit
        call   ebx
        mov    [con_kbhit], eax
        push   ecx
        push   sz_con_printf
        call   ebx
        mov    [con_printf], eax
				
        ; push   ecx
        ; push   sz_con_init
        ; call   ebx
        ; mov    [con_init], eax
        ; push   con_caption
        ; push   -1
        ; push   -1
        ; push   -1
        ; push   -1
        ; call   [con_init]
				
				
.do_nothing:
        ret

; ------------------------------------------------------------- ;
load.library:
        mov    eax, 68
        mov    ebx, 19
        mov    ecx, [esp + 4]
        int    64
        ret    4
; ------------------------------------------------------------- ;
getprocaddress:
        mov    edx, [esp + 8]
        xor    eax, eax
        test   edx, edx
        jz     .end
.next:
        xor    eax, eax
        cmp    [edx], dword 0
        jz     .end
        mov    esi, [edx]
        mov    edi, [esp + 4]
.next_:
        lodsb
        scasb
        jne    .fail
        or     al, al
        jnz    .next_
        jmp    .ok
.fail:
        add    edx, 8
        jmp    .next
.ok:
        mov    eax, [edx + 4]
.end:
        ret    8
; ------------------------------------------------------------- ;

section '.data' align 16

; con_caption         db "",0
; con_init            dd 0
con_getch           dd 0
con_kbhit           dd 0
con_printf          dd 0
console             dd 0
; sz_con_init         db "con_init",0
sz_con_getch        db "con_getch",0
sz_con_kbhit        db "con_kbhit",0
sz_con_printf       db "con_printf",0
sz_console          db "/sys/lib/console.obj",0